#ifndef HARKTOOL4_IRPROVIDERIR_HPP
#define HARKTOOL4_IRPROVIDERIR_HPP

#include <string>
#include "IRProvider.hpp"

namespace harktool4
{

/* @brief ImpulseResponseListFileからインパルス応答を提供する.
 */
class IRProviderIR : public IRProvider
{
public:
    IRProviderIR(const std::string& ir_list_file);
    IRProviderIR(const IRProviderIR&) = delete;
    IRProviderIR& operator=(const IRProviderIR&) = delete;

    virtual std::vector<float> GetIR(size_t src_index, size_t mic_index);
    virtual size_t GetNumSrc();
    virtual size_t GetNumMic();
    virtual std::vector<boost::shared_ptr<harkio2::harkconfig::Source>> GetSources();

private:
    class Impl;
    boost::shared_ptr<Impl> impl_;
};

}

#endif // HARKTOOL4_IRPROVIDERIR_HPP

